library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity EvoBlock_TB is
end EvoBlock_TB;

architecture TestBench of EvoBlock_TB is

	component EvoBlock is
		generic (NUM_ARRAYS	: integer := 8;
					NUM_COLS		: integer := 5);
		port (	clk			: in	std_logic;
					reset			: in	std_logic;
					arrayNum		: in	integer range 0 to (NUM_ARRAYS-1);
					cellNum		: in	integer range 0 to ((NUM_COLS*8)-1);
					configDIn	: in	std_logic_vector(19 downto 0);
					configWEn	: in	std_logic;
					ramDIn		: in	std_logic_vector(7 downto 0);
					ramWEn		: in	std_logic;
					ramDOut		: out	std_logic_vector(7 downto 0);
					vector		: in	std_logic_vector(7 downto 0);
					mask			: in	std_logic_vector(7 downto 0);
					output		: out std_logic_vector(((NUM_ARRAYS*8)-1) downto 0);
					match			: out std_logic_vector(((NUM_ARRAYS*8)-1) downto 0));
	end component;

	constant NUM_ARRAYS : integer := 8;
	constant NUM_COLS : integer := 5;

	signal clk			: std_logic;
	signal reset		: std_logic;
	signal arrayNum	: integer range 0 to (NUM_ARRAYS-1);
	signal cellNum		: integer range 0 to ((NUM_COLS*8)-1);
	signal configDIn	: std_logic_vector(19 downto 0);
	signal configWEn	: std_logic;
	signal ramDIn		: std_logic_vector(7 downto 0);
	signal ramWEn		: std_logic;
	signal ramDOut		: std_logic_vector(7 downto 0);
	signal vector		: std_logic_vector(7 downto 0);
	signal mask			: std_logic_vector(7 downto 0);
	signal output		: std_logic_vector(((NUM_ARRAYS*8)-1) downto 0);
	signal match		: std_logic_vector(((NUM_ARRAYS*8)-1) downto 0);

begin

MainClk : process
begin
	clk <= '1';
	wait for 5 ns;		-- 50 MHz
	clk <= '0';
	wait for 5 ns;
end process;

UUT : EvoBlock
generic map(NUM_ARRAYS	=> NUM_ARRAYS,
				NUM_COLS		=> NUM_COLS)
port map(	clk			=> clk,
				reset			=> reset,
				arrayNum		=> arrayNum,
				cellNum		=> cellNum,
				configDIn	=> configDIn,
				configWEn	=> configWEn,
				ramDIn		=> ramDIn,
				ramWEn		=> ramWEn,
				ramDOut		=> ramDOut,
				vector		=> vector,
				mask			=> mask,
				output		=> output,
				match			=> match);

TB : process
begin

	reset <= '1';
	arrayNum <= 0;
	cellNum <= 0;

	configDIn <= (others => '0');
	configWEn <= '0';

	ramDIn <= (others => '0');
	ramWEn <= '0';

	vector <= (others => '0');
	mask <= (others => '0');


	wait until (clk'event and clk='1');
	wait until (clk'event and clk='1');

	reset <= '0';

	wait;

end process;

end TestBench;

